Attribute VB_Name = "modGasTurbine"
Option Explicit
Dim MWi(1 To 21) As Single
Dim LHVi(1 To 21) As Single
Dim C5(1 To 21) As Single 'N2
Dim C7(1 To 21) As Single 'O2
Dim C9(1 To 21) As Single 'CO2
Dim C11(1 To 21) As Single 'H2O
Dim C13(1 To 21) As Single 'AR
Dim C15(1 To 21) As Single 'SO2
Dim cfout(1 To 10, 1) As Variant
Dim Comb_Ext_Cooling As Single
Dim e_comb As Single

Function Convert_Fractions(Comp_A As Variant, iNumComp As Integer, iMode As Integer)
ReDim X(1 To iNumComp) As Single
ReDim Y(1 To iNumComp) As Single
ReDim n(1 To iNumComp) As Single
Dim n_tot As Single, mwt As Single
Dim i As Integer
On Local Error GoTo err_here

Select Case iMode
    Case 1  'Mole fracs to mass fracs..
        For i = 1 To iNumComp
            Y(i) = Comp_A(i)
        Next i
        mwt = MWgas(Y, iNumComp)
        For i = 1 To iNumComp
            X(i) = (1 / mwt) * Y(i) * MW(i)
            cfout(i, 0) = X(i)
        Next i
        
    Case Else   ''Mass fracs to mole fracs..
        n_tot = 0
        For i = 1 To iNumComp
            X(i) = Comp_A(i)
            n(i) = X(i) / MW(i)
            n_tot = n_tot + n(i)
        Next i
        For i = 1 To iNumComp
            Y(i) = n(i) / n_tot
            cfout(i, 0) = Y(i)
        Next i

End Select

Convert_Fractions = 1

Exit Function
err_here:
Convert_Fractions = Err.Number
End Function

Function Convert_to_JANAF_Composition(y_A As Variant) As Integer
On Local Error GoTo err_here
'
'CO2
cfout(1, 0) = y_A(4)
'H2O
cfout(2, 0) = y_A(3)
'CO
cfout(3, 0) = 0
'H2
cfout(4, 0) = 0
'O2
cfout(5, 0) = y_A(2)
'N2 + Ar
cfout(6, 0) = y_A(1) + y_A(5)
cfout(7, 0) = 0
cfout(8, 0) = 0
cfout(9, 0) = 0
cfout(10, 0) = 0

Convert_to_JANAF_Composition = 1

Exit Function
err_here:
Convert_to_JANAF_Composition = Err.Number
End Function

Function Find_Mfuel(mf1 As Single, mf2 As Single, CompAir As Variant, CompFuel As Variant, Minj As Single, _
Hinj As Single, Mair As Single, Tair As Single, Tfuel As Single, Tfire As Single) As Single
' Find fuel flow as a function of firing temperature & composition
' Fire is firing temperature
' Comp is composition with iNumComp components
' mf1 and mf2 are low and high estimates
' xacc is the desired accuracy
Const JMAX As Integer = 40
Const Tacc As Single = 0.001
Dim j As Integer
Dim dx As Single, f As Single, fmid As Single, xmid As Single, rtbis As Single
Dim varCombust As Variant
'
1:
varCombust = Combust(Mair, mf2, Minj, Hinj, CompAir, CompFuel, Tair, Tfuel)
fmid = Tfire - CSng(varCombust(1, 0))
varCombust = Combust(Mair, mf1, Minj, Hinj, CompAir, CompFuel, Tair, Tfuel)
f = Tfire - CSng(varCombust(1, 0))
'
If (f * fmid >= 0) Then
' Root is not bracketed..
    mf1 = mf1 - 0.1
    If (mf1 < 0) Then
        Find_Mfuel = -999
        Exit Function
    End If
    mf2 = mf2 + 0.1
    If (mf2 > 100) Then
        Find_Mfuel = -999
        Exit Function
    End If
    GoTo 1
End If
If (f < 0) Then
    rtbis = mf1
    dx = mf2 - mf1
Else
    rtbis = mf2
    dx = mf1 - mf2
End If
For j = 1 To JMAX
    dx = dx / 2
    xmid = rtbis + dx
    varCombust = Combust(Mair, xmid, Minj, Hinj, CompAir, CompFuel, Tair, Tfuel)
    fmid = Tfire - CSng(varCombust(1, 0))
    If (fmid <= 0) Then
        rtbis = xmid
    End If
    If (Abs(dx) < Tacc Or fmid = 0) Then
        Find_Mfuel = rtbis
        Exit Function
    End If
Next j
Find_Mfuel = -999
End Function

Sub Get_Fuel_Data()
'Compound   yi      MW[lb/lbmol]    LHV[Btu/lb]
'CH4        1.0000  16.04276        21,503
'C2H6       0.0000  30.06964        20,432
'C2H4       0.0000  28.05376        20,278
'C3H8       0.0000  44.09652        19,923
'C3H6       0.0000  42.08064        19,678
'C4H10-n    0.0000  58.12340        19,587
'C4H10-iso  0.0000  58.12340        19,659
'C4H8       0.0000  56.10752        19,450
'C5H12-is   0.0000  72.15028        19,456
'C5H12-n    0.0000  72.15028        19,498
'C5H10      0.0000  70.13440        19,328
'C6H14      0.0000  86.17716        19,353
'N2         0.0000  28.01348        0
'CO         0.0000  28.01040        4,342
'CO2        0.0000  44.09800        0
'H2O        0.0000  18.01528        0
'H2         0.0000  2.01588         51,566
'H2S        0.0000  34.08188        6,534
'He         0.0000  4.00260         0
'O2         0.0000  31.99880        0
'Ar         0.0000  39.94800        0

MWi(1) = 16.04276
MWi(2) = 30.06964
MWi(3) = 28.05376
MWi(4) = 44.09652
MWi(5) = 42.08064
MWi(6) = 58.1234
MWi(7) = 58.1234
MWi(8) = 56.10752
MWi(9) = 72.15028
MWi(10) = 72.15028
MWi(11) = 70.1344
MWi(12) = 86.17716
MWi(13) = 28.01348
MWi(14) = 28.0104
MWi(15) = 44.098
MWi(16) = 18.01528
MWi(17) = 2.01588
MWi(18) = 34.08188
MWi(19) = 4.0026
MWi(20) = 31.9988
MWi(21) = 39.948
'
'5-2.4.3 Fuel Compound Heating Value Table. Table 5-2.4.3-1 is taken from ASTM D 3588-98. It
'has been updated based upon GPA Standard 2145-03 in accordance with ASTM D 3588 Table 1, Footnote A.
'The most current version of these standards should be used. The heating values for butanes, pentanes, and
'hexanes are average values for the various isomers. The heats of combustion are based upon 60F and 14.696
'psia.

LHVi(1) = 21503
LHVi(2) = 20432
LHVi(3) = 20278
LHVi(4) = 19923
LHVi(5) = 19678
LHVi(6) = 19587
LHVi(7) = 19659
LHVi(8) = 19450
LHVi(9) = 19456
LHVi(10) = 19498
LHVi(11) = 19328
LHVi(12) = 19353
LHVi(13) = 0
LHVi(14) = 4342
LHVi(15) = 0
LHVi(16) = 0
LHVi(17) = 51566
LHVi(18) = 6534
LHVi(19) = 0
LHVi(20) = 0
LHVi(21) = 0

End Sub

Function Calc_Fuel_LHV(yFuel As Variant) As Single
Dim Sum1 As Single
Dim i As Integer
Dim MW_Fuel As Single

Call Get_Fuel_Data

Sum1 = 0
For i = 1 To 21
    Sum1 = Sum1 + yFuel(i) * MWi(i) * LHVi(i)
Next i
MW_Fuel = Calc_Fuel_MW(yFuel)
Calc_Fuel_LHV = Sum1 / MW_Fuel

End Function
Function Calc_Fuel_MW(yFuel As Variant) As Single
Dim Sum2 As Single
Dim i As Integer

Call Get_Fuel_Data

Sum2 = 0
For i = 1 To 21
    Sum2 = Sum2 + yFuel(i) * MWi(i)
Next i

Calc_Fuel_MW = Sum2

End Function

Sub Combustion_Ratios_Table()
'Compound       N2  O2      CO2 H2O Ar  SO2
'CH4            0   -2      1   2   0   0
'C2H6           0   -3.5    2   3   0   0
'C2H4           0   -3      2   2   0   0
'C3H8           0   -5      3   4   0   0
'C3H6           0   -4.5    3   3   0   0
'C4H10-n        0   -6.5    4   5   0   0
'C4H10-iso      0   -6.5    4   5   0   0
'C4H8           0   -6      4   4   0   0
'C5H12-iso      0   -8      5   6   0   0
'C5H12-n        0   -8      5   6   0   0
'C5H10          0   -7.5    5   5   0   0
'C6H14          0   -9.5    6   7   0   0
'N2             1   0       0   0   0   0
'CO             0   -0.5    1   0   0   0
'CO2            0   0       1   0   0   0
'H2O            0   0       0   1   0   0
'H2             0   -0.5    0   1   0   0
'H2S            0   -1.5    0   1   0   1
'He             0   0       0   0   0   0
'O2             0   1       0   0   0   0
'Ar             0   0       0   0   1   0
Dim i As Integer
'5-2.2.3 Table of Combustion Ratios. Table 5-2.2.3-1 shows the ratios of air constituent molar flow
'change per mole of fuel gas compound combusted. The molar flow of any inert compound in the fuel gas
'such as nitrogen or carbon dioxide would pass directly into the combustion products on a mole-per-mole
'basis. The table values are determined from an oxidation chemical equation for a unit mole of fuel gas
'compound in accordance with the following generic oxidation equation:
'    CxHySz + (x + y/4 + z)O2 = (x)CO2 + (y/2)H2O + (z)SO2

For i = 1 To 21
    C5(i) = 0
    C7(i) = 0
    C9(i) = 0
    C11(i) = 0
    C13(i) = 0
    C15(i) = 0
Next i

C5(13) = 1
C13(21) = 1
C15(18) = 1

C7(1) = -2#
C7(2) = -3.5
C7(3) = -3#
C7(4) = -5#
C7(5) = -4.5
C7(6) = -6.5
C7(7) = -6.5
C7(8) = -6#
C7(9) = -8#
C7(10) = -8#
C7(11) = -7.5
C7(12) = -9.5
C7(14) = -0.5
C7(17) = -0.5
C7(18) = -1.5
C7(20) = 1#

C9(1) = 1#
C9(2) = 2#
C9(3) = 2#
C9(4) = 3#
C9(5) = 3#
C9(6) = 4#
C9(7) = 4#
C9(8) = 4#
C9(9) = 5#
C9(10) = 5#
C9(11) = 5#
C9(12) = 6#
C9(14) = 1#
C9(15) = 1#

C11(1) = 2#
C11(2) = 3#
C11(3) = 2#
C11(4) = 4#
C11(5) = 3#
C11(6) = 5#
C11(7) = 5#
C11(8) = 4#
C11(9) = 6#
C11(10) = 6#
C11(11) = 5#
C11(12) = 7#
C11(16) = 1#
C11(17) = 1#
C11(18) = 1#

End Sub

Function Combust(m_a As Single, m_f As Single, m_i As Single, h_i As Single, _
    y_A As Variant, y_f As Variant, T_a As Single, T_f As Single) As Variant
'
' m_a = Combustor airflow, pps
' m_f = Combustor fuel flow, pps
' m_i = Combustor injection flow, pps
' h_i = Combustor injection enthalpy, Btu/lb
' y_a = Air composition (molar)
' y_f = Fuel composition (molar)
' T_a = Air temperature, F
' T_f = Fuel temperature, F
Dim h_a As Single, h_f As Single, LHVf As Single, x_a(1 To 6) As Single
Dim MW_a As Single, MW_f As Single, ntot As Single
Dim E_in As Single, E_out As Single, T_gas_out As Single, x_gas_out(1 To 6) As Single
Dim h_gas_out As Single, n_gas_out(1 To 6) As Single, y_gas_out(1 To 6) As Single
Dim i As Integer
Dim dn(1 To 6) As Single
Dim vOutputArray(1 To 30, 1) As Single

On Local Error GoTo err_here

MW_f = Calc_Fuel_MW(y_f)    'mol. wt. of fuel
LHVf = Calc_Fuel_LHV(y_f)   'LHV of fuel
MW_a = MWgas(y_A, 6)        'mol. wt. of air
Call Combustion_Ratios_Table

' PTC 4.4 Sheet C Calculations:
For i = 1 To 6
    dn(i) = 0
Next i
For i = 1 To 21
    dn(1) = dn(1) + y_f(i) * C5(i) * m_f / MW_f     'N2
    dn(2) = dn(2) + y_f(i) * C7(i) * m_f / MW_f     'O2
    dn(3) = dn(3) + y_f(i) * C11(i) * m_f / MW_f    'H2O
    dn(4) = dn(4) + y_f(i) * C9(i) * m_f / MW_f     'CO2
    dn(5) = dn(5) + y_f(i) * C13(i) * m_f / MW_f    'AR
    dn(6) = dn(6) + y_f(i) * C15(i) * m_f / MW_f    'SO2
Next i
'
' PTC 4.4 Sheet E Calculations:
ntot = 0
For i = 1 To 6
    n_gas_out(i) = (m_a / MW_a) * y_A(i) + dn(i)
    If i = 3 Then
        n_gas_out(i) = n_gas_out(i) + m_i / MW(3)
    End If
    ntot = ntot + n_gas_out(i)
Next i
' Mass composition of air:
i = Convert_Fractions(y_A, 6, 1)
For i = 1 To 6
    x_a(i) = cfout(i, 0)
Next i
' Molar composition of combustor exit gas:
For i = 1 To 6
    y_gas_out(i) = n_gas_out(i) / ntot
Next i
' Mass composition of combustor exit gas:
i = Convert_Fractions(y_gas_out, 6, 1)
For i = 1 To 6
    x_gas_out(i) = cfout(i, 0)
Next i

h_a = hgas(T_a, x_a, 6, 2)
h_f = T_f ^ 2 / 4720 + 0.491 * T_f - 30.2
' Combustor energy balance:
E_in = m_a * h_a + m_f * (LHVf + h_f) + m_i * (h_i - 1087.73)
' Combustor efficiency - specified outside
' If Combust is called directly, use a default...
If e_comb = 0 Then
    e_comb = 0.995
End If
' Combustor cooling (e.g., in G class GTs)
' Specified outside
' If Combust is called directly, it is zero...
E_out = E_in - (1 - e_comb) * m_f * LHVf - Comb_Ext_Cooling
h_gas_out = E_out / (m_a + m_f + m_i)
T_gas_out = Find_Tgas(1000, 4000, x_gas_out, 6, 2, h_gas_out)

'Combust = T_gas_out
vOutputArray(1, 0) = T_gas_out
vOutputArray(2, 0) = y_gas_out(1)
vOutputArray(3, 0) = y_gas_out(2)
vOutputArray(4, 0) = y_gas_out(3)
vOutputArray(5, 0) = y_gas_out(4)
vOutputArray(6, 0) = y_gas_out(5)
vOutputArray(7, 0) = y_gas_out(6)

Combust = CVar(vOutputArray)

Exit Function
err_here:
Combust = Err.Number

End Function

Function ICE(vInputArray As Variant, yAir As Variant, yFuel As Variant) As Variant
'
Dim P0 As Single, T0 As Single, v0 As Single, h0 As Single, u0 As Single, s0 As Single, MW0 As Single
Dim P1 As Single, T1 As Single, v1 As Single, h1 As Single, u1 As Single, s1 As Single, MW1 As Single
Dim P7 As Single, T7 As Single, h7 As Single, v1b As Single
Dim P2 As Single, T2 As Single, v2 As Single, h2 As Single, u2 As Single, s2 As Single, MW2 As Single
Dim P3 As Single, T3 As Single, v3 As Single, h3 As Single, u3 As Single, s3 As Single, MW3 As Single
Dim P4 As Single, T4 As Single, v4 As Single, h4 As Single, u4 As Single, s4 As Single, MW4 As Single
Dim P5 As Single, T5 As Single, v5 As Single, h5 As Single, u5 As Single, s5 As Single, MW5 As Single
Dim P6 As Single, T6 As Single, v6 As Single, h6 As Single, u6 As Single, s6 As Single, MW6 As Single
Dim RC As Single, Mair As Single, Mfuel As Single, W_TC_Comp As Single, W_TC_Turb As Single
Dim W_Comp_Stroke As Single, W_Exp_Stroke As Single, W_Net As Single, Q_in As Single, FuelLHV As Single
Dim k As Single, TC_Comp_Eff As Single, TC_Turb_Eff As Single, P_Cyl_Max As Single, P_Max_BP As Single
Dim Comb_Loss_Fraction As Single, Eff_ICE As Single, Heat_Rate_SI As Single
Dim PR_TC_Comp As Single, PR_TC_Turb As Single, Q_TC_AfterCooler As Single, Q_loss As Single
Dim Cv_Avg_Comp As Single, Cv_Avg_Exp As Single, gamma_avg_C As Single
Dim Cp_Avg_Comp As Single, Cp_Avg_Exp As Single, gamma_avg_E As Single
Dim Eff_Combustion As Single, Eff_Expansion As Single, Mech_Loss_Fraction As Single, Radiation_Loss_Fraction As Single
Dim Lube_Oil_HT As Single, Radiation_Loss As Single, Q_Exhaust As Single, Q_Air As Single, HB_Error As Single
Dim y_CO2_x As Single, y_H2O_x As Single, y_O2_x As Single, y_N2Ar_x As Single
Dim a1 As Single, a3 As Single, a3_1 As Single, a4 As Single, Avail_Ratio As Single
Dim i As Integer, Comb_Exit_Enthalpy_Calc_Mode As Integer
Dim N_Cyl As Integer, Bore As Single, Stroke As Single, rpm As Single, OpCycle As Single, MEP As Single
Dim A_Cyl As Single, Piston_Speed As Single, V_d As Single, Eta_v As Single, Lost_Expansion_Work As Single
Dim Lost_TCTurbine_Work As Single, Tref As Single, href As Single, sref As Single, uref As Single, Pref As Single
Dim x_a(1 To 6) As Single, MWAIR As Single, x_3g(1 To 6) As Single, y_3g(1 To 6) As Single
Dim alfa As Single, beta As Single, q_str As Single, x_cv As Single, u3_isothm As Single
Dim Mass_TDC As Single, VV5 As Single, DQ As Single, HH2 As Single, HH3 As Single, UU2 As Single, UU3 As Single
Dim Eff_Compression As Single
Dim varCombust As Variant
Dim y_J0(1 To 10) As Single
Dim y_J1(1 To 10) As Single
Dim y_J2(1 To 10) As Single
Dim y_J3(1 To 10) As Single
Dim y_J4(1 To 10) As Single
Dim y_J5(1 To 10) As Single
Dim y_J6(1 To 10) As Single
Dim vOutputArray(1 To 40, 1) As Single
Const N_Comp_Stages As Integer = 18
Const Runv As Single = 1.986    'Btu/lbmol-R
On Local Error GoTo err_here
'
' Read the input array:
N_Cyl = vInputArray(1)
Bore = vInputArray(2)   'in mm
Stroke = vInputArray(3) 'in mm
rpm = vInputArray(4)
OpCycle = vInputArray(5)
'-----------------------------------
TC_Comp_Eff = vInputArray(6)
Radiation_Loss_Fraction = vInputArray(7)
Mech_Loss_Fraction = vInputArray(8)
Eff_Combustion = vInputArray(9)
Eff_Expansion = vInputArray(10)
P0 = vInputArray(11)
T0 = vInputArray(12)
RC = vInputArray(13) 'Compression ratio
Mair = vInputArray(14)  'in pps
Mfuel = vInputArray(15) 'in pps
PR_TC_Comp = vInputArray(16) 'Turbocharger compressor PR
PR_TC_Turb = vInputArray(17) 'Turbocharger turbine PR
T1 = vInputArray(18) 'After T/C cooler
Comb_Loss_Fraction = vInputArray(19) 'Combustor Loss
Tref = vInputArray(20)  '0 enthalpy reference temp.
Pref = 14.696
P_Cyl_Max = vInputArray(21) * 145.04 'Max. cylinder pressure given as MPa --> to psia
P_Max_BP = vInputArray(22) * 0.0145037738 'Max. admissible back pressure given as mbar --> to psia
Comb_Exit_Enthalpy_Calc_Mode = vInputArray(23)  '0 for the improved/preferred method
Eff_Compression = vInputArray(24)
If (Eff_Compression <= 0) Then Eff_Compression = 1
If (P_Max_BP <= 0) Then
    P_Max_BP = 15
End If
If (P_Cyl_Max <= 0) Then P_Cyl_Max = 50 * 145.04
'----------------------------------------------------------
P7 = P0 * PR_TC_Comp   'after turbocharger
P1 = P7 * 0.99
' Mass composition of air:
i = Convert_Fractions(yAir, 6, 1)
For i = 1 To 6
    x_a(i) = cfout(i, 0)
Next i
MWAIR = MWgas(yAir, 6)  'Mol. wt. of air..
'Turbocharger Compressor:
T7 = T0
h0 = hgas(T0, x_a, 6, 2)
If (PR_TC_Comp = 1) Then
    h7 = h0
    W_TC_Comp = 0
Else
    For i = 1 To N_Comp_Stages
        k = 1 - 1 / gamma(T7, yAir, 6)
        T7 = (T7 + 459.67) * (PR_TC_Comp ^ (1 / N_Comp_Stages)) ^ (k / TC_Comp_Eff) - 459.67
    Next i
    h7 = hgas(T7, x_a, 6, 2)
    W_TC_Comp = Mair * (h7 - h0) * 1.05506
End If
v1b = (Runv / MWAIR) * (T7 + 459.67) * 778.17 / P7 / 144    'cuft/lb
'Compression stroke inlet:
v1 = (Runv / MWAIR) * (T1 + 459.67) * 778.17 / P1 / 144
'Calculate Piston Speed:
A_Cyl = pi() / 4 * (Bore / 10 * 0.3937) ^ 2 'in sqin
Piston_Speed = 2 * (Stroke / 1000) * (rpm / 60) 'mean piston speed
V_d = (Stroke / 10 * 0.3937) * A_Cyl * N_Cyl    'Displacement volume in cuin
Eta_v = 2 * Mair * v1 * (144 * 12) / V_d / (rpm / 60)
' JANAF mole fractions:
i = Convert_to_JANAF_Composition(yAir)
For i = 1 To 10
    y_J1(i) = cfout(i, 0)
    y_J0(i) = y_J1(i)
    y_J2(i) = y_J1(i)
Next i
MW1 = 0
For i = 1 To 10
    MW1 = MW1 + y_J1(i) * MW_JANAF(i)
Next i
MW0 = MW1
MW2 = MW1
h0 = props("h", T0, P0, y_J0, 1)
h7 = props("h", T7, P7, y_J0, 1)
h1 = props("h", T1, P1, y_J1, 1)
Q_TC_AfterCooler = Mair * (h7 - h1) * 1.05506
Q_Air = Mair * (h1 - props("h", Tref, 14.7, y_J1, 1)) * 1.05506  'kWth
u1 = h1 - P1 * v1 * (144 / 778.17)
s1 = props("s", T1, P1, y_J1, 1)
href = props("h", Tref, 14.696, y_J1, 1)
sref = props("s", Tref, 14.696, y_J1, 1)
uref = href - (Runv / MW1) * (Tref + 459.67)
a1 = (props("h", T1, P1, y_J1, 1) - href) - _
    (Tref + 459.67) * (props("s", T1, P1, y_J1, 1) - sref)
'Compression stroke outlet:
1:
v2 = v1 / RC
Mass_TDC = V_d * (1 / 12) ^ 3 / v2
s2 = s1
T2 = TSV(59, 1500, y_J2, 10, 1, v2, s2)
P2 = (Runv / MW2) * (T2 + 459.67) / v2 * (778.17 / 144)
h2 = props("h", T2, P2, y_J2, 1)
HH2 = h2 - href
u2 = h2 - P2 * v2 * (144 / 778.17)
UU2 = u2 - uref
W_Comp_Stroke = Mair * (u2 - u1) * 1.05506
W_Comp_Stroke = W_Comp_Stroke / Eff_Compression
u2 = u1 + W_Comp_Stroke / (Mair * 1.05506)
T2 = TU(500, 2500, y_J2, 10, 1, u2)
Cv_Avg_Comp = (u2 - u1) / (T2 - T1)
Cp_Avg_Comp = (h2 - h1) / (T2 - T1)
gamma_avg_C = Cp_Avg_Comp / Cv_Avg_Comp
' Combustion
e_comb = 1 - Comb_Loss_Fraction
Comb_Ext_Cooling = 0
' First call just to get the burned gas composition..
varCombust = Combust(Mair, Mfuel, 0, 0, yAir, yFuel, T2, 80)
T3 = CSng(varCombust(1, 0))
FuelLHV = Calc_Fuel_LHV(yFuel)
'----------------------Get gas compositions:
For i = 1 To 6
    x_3g(i) = cfout(i, 0)
Next i
i = Convert_Fractions(x_3g, 6, 2)
For i = 1 To 6
    y_3g(i) = cfout(i, 0)
Next i
i = Convert_to_JANAF_Composition(y_3g)
For i = 1 To 10
    y_J3(i) = cfout(i, 0)
    y_J4(i) = y_J3(i)
    y_J5(i) = y_J3(i)
    y_J6(i) = y_J3(i)
Next i
' Exhaust Gas Composition:
y_CO2_x = y_J5(1)
y_H2O_x = y_J5(2)
y_O2_x = y_J5(5)
y_N2Ar_x = y_J5(6)

MW3 = 0
For i = 1 To 10
    MW3 = MW3 + y_J3(i) * MW_JANAF(i)
Next i
MW4 = MW3
MW5 = MW3
MW6 = MW3
'-------------------------------------------------------------
Q_in = Mfuel * FuelLHV * 1.05506
Q_loss = Comb_Loss_Fraction * Q_in
v3 = v2 'Heywood, 5-7b
P3 = (Runv / MW3) * (T3 + 459.67) / v3 * (778.17 / 144)
If (Comb_Exit_Enthalpy_Calc_Mode = 0) Then
' Improved & Preferred Calculation Method
' SCG|12.24.14
    u3 = u2 'Heywood, 5-7b
    T3 = TU(1000, 4500, y_J3, 10, 1, u3)
    T3 = (T3 + 459.67) * Eff_Combustion - 459.67
    h3 = props("h", T3, P3, y_J3, 1)
    P3 = (Runv / MW3) * (T3 + 459.67) / v3 * (778.17 / 144)
    ' Reference enthalpy and internal energy:
    href = props("h", Tref, 14.696, y_J3, 1)
    uref = href - (Runv / MW3) * (Tref + 459.67)
    u3_isothm = props("h", T2, 14.696, y_J3, 1) - (Runv / MW3) * (T2 + 459.67)
    UU3 = u3_isothm - uref
    HH3 = h3 - href
'    DQ = ((Mair + Mfuel) * HH3 - Mair * HH2) / Q_in
    DQ = -((Mair + Mfuel) * u3_isothm - Mair * u2) / Q_in
Else
    h3 = (Mair * h2 + Mfuel * FuelLHV * e_comb) / (Mair + Mfuel)
    u3 = h3 - P3 * v3 * (144 / 778.17)
    ' Calculate T3 here:
    T3 = TU(1000, 4500, y_J3, 10, 1, u3)
    P3 = (Runv / MW3) * (T3 + 459.67) / v3 * (778.17 / 144)
    ' Reference enthalpy and internal energy:
    href = props("h", Tref, 14.696, y_J3, 1)
    sref = props("s", Tref, 14.696, y_J3, 1)
    a3 = (props("h", T3, P3, y_J3, 1) - href) - _
        (Tref + 459.67) * (props("s", T3, P3, y_J3, 1) - sref)
    T3 = (T3 + 459.67) * Eff_Combustion - 459.67
    '
    P3 = (Runv / MW3) * (T3 + 459.67) / v3 * (778.17 / 144)
    a3_1 = (props("h", T3, P3, y_J3, 1) - href) - _
        (Tref + 459.67) * (props("s", T3, P3, y_J3, 1) - sref)
    Avail_Ratio = a3_1 / a3
    ' Start of expansion stroke
    If P3 > P_Cyl_Max Then
        P3 = P_Cyl_Max
        v3 = (Runv / MW3) * (T3 + 459.67) / P3 * (778.17 / 144)
    End If
    h3 = props("h", T3, P3, y_J3, 1)
    u3 = h3 - P3 * v3 * (144 / 778.17)
End If
'
v4 = v3
' Calibration to maximum cylinder pressure (17.8 Mpa) in Sutkowski paper
' SCG|05.25.2016
' P4 = P3 * 0.622259
T4 = T3
'
beta = v4 / v3
alfa = P4 / P2
q_str = (Mfuel / Mair) * FuelLHV / RC ^ (gamma_avg_C - 1)
x_cv = (T4 - T2) / ((Mfuel / Mair) * (FuelLHV / Cv_Avg_Comp))   'Burned Mass Fraction
'
h4 = props("h", T4, P4, y_J4, 1)
u4 = h4 - P4 * v4 * (144 / 778.17)
s4 = props("s", T4, P4, y_J4, 1)
a4 = (props("h", T4, P4, y_J4, 1) - href) - _
    (Tref + 459.67) * (props("s", T4, P4, y_J4, 1) - sref)
Avail_Ratio = (a4 - a1) / (a3 - a1)
' End of expansion stroke
P6 = P0 / 0.95
P6 = P_Max_BP   '12/08/14 SCG
P5 = P6 * PR_TC_Turb
s5 = s4
T5 = TSP(59, 1500, y_J5, 10, 1, P5, s5) 'isentropic
v5 = (Runv / MW5) * (T5 + 459.67) * 778.17 / P5 / 144
VV5 = Mass_TDC * v5 * 12 ^ 3    'V_d
h5 = props("h", T5, P5, y_J5, 1)
u5 = h5 - P5 * v5 * (144 / 778.17)
W_Exp_Stroke = (Mair + Mfuel) * (u4 - u5) * 1.05506
Lost_Expansion_Work = W_Exp_Stroke * (1 - Eff_Expansion)
W_Exp_Stroke = W_Exp_Stroke * Eff_Expansion
'-------------------------------------------------------------------
u5 = u4 - (W_Exp_Stroke / 1.05506) / (Mair + Mfuel)
T5 = TUP(59, 1500, y_J5, 10, 1, P5, u5) 'actual
v5 = (Runv / MW5) * (T5 + 459.67) * 778.17 / P5 / 144
h5 = u5 + P5 * v5 * (144 / 778.17)
'-------------------------------------------------------------------
W_Net = W_Exp_Stroke - W_Comp_Stroke
Lube_Oil_HT = Mech_Loss_Fraction * W_Net '
Radiation_Loss = Radiation_Loss_Fraction * W_Net
W_Net = W_Net - Lube_Oil_HT - Radiation_Loss
Eff_ICE = W_Net / Q_in
Heat_Rate_SI = 3412.14 / Eff_ICE * 1.05506
MEP = (W_Net / N_Cyl) * OpCycle * 24 * 10000000# / (Bore ^ 2 * rpm * Stroke * pi())
Cv_Avg_Exp = (u4 - u5) / (T4 - T5)
Cp_Avg_Exp = (h4 - h5) / (T4 - T5)
gamma_avg_E = Cp_Avg_Exp / Cv_Avg_Exp
'Turbocharger Turbine:
s6 = s5
T6 = TSP(59, 2500, y_J6, 10, 1, P6, s6)
v6 = (Runv / MW6) * (T6 + 459.67) * 778.17 / P6 / 144
h6 = props("h", T6, P6, y_J6, 1)
u6 = h6 - P6 * v6 * (144 / 778.17)
Q_Exhaust = (Mair + Mfuel) * (h5 - props("h", Tref, 14.7, y_J5, 1)) * 1.05506 'kWth
'Q_Exhaust = (Mair + Mfuel) * (h6 - props("h", Tref, 14.7, y_J6, 1)) * 1.05506 'kWth
TC_Turb_Eff = TC_Comp_Eff * 0.95
W_TC_Turb = (Mair + Mfuel) * (h5 - h6) * 1.05506
Lost_TCTurbine_Work = W_TC_Turb * (1 - TC_Turb_Eff)
W_TC_Turb = W_TC_Turb * TC_Turb_Eff 'drives the T/C compressor
'-------------------------------------------------------------------
h6 = h5 - (W_TC_Turb / 1.05506) / (Mair + Mfuel)
T6 = TH(500, 4500, y_J6, 10, 1, h6)
v6 = (Runv / MW6) * (T6 + 459.67) * 778.17 / P6 / 144
u6 = h6 - P6 * v6 * (144 / 778.17)
'-------------------------------------------------------------------
Q_loss = Q_in + Q_Air - W_Net - Q_Exhaust
HB_Error = (Q_in + Q_Air - Q_loss - Q_Exhaust)
HB_Error = HB_Error - W_Net '(W_Exp_Stroke - W_Comp_Stroke) '- W_TC_Turb
HB_Error = HB_Error / Q_in
' Lost_TCTurbine_Work
' Lost_Expansion_Work
' Recalculate piston speed
' Heywood (2.43)
Piston_Speed = 4 * (W_Net / A_Cyl / N_Cyl) / (Eta_v * Eff_ICE) / (Mfuel / Mair) * (v1 * 1728) * 0.0254  'm/s
Piston_Speed = Piston_Speed / (FuelLHV * 1.05506)
'
vOutputArray(1, 0) = W_TC_Comp
vOutputArray(2, 0) = W_TC_Turb
vOutputArray(3, 0) = W_Comp_Stroke
vOutputArray(4, 0) = W_Exp_Stroke
vOutputArray(5, 0) = W_Net
vOutputArray(6, 0) = Q_in
vOutputArray(7, 0) = Eff_ICE
vOutputArray(8, 0) = Q_TC_AfterCooler
vOutputArray(9, 0) = P1
vOutputArray(10, 0) = T1
vOutputArray(11, 0) = P7
vOutputArray(12, 0) = T7
vOutputArray(13, 0) = P2
vOutputArray(14, 0) = T2
vOutputArray(15, 0) = P3
vOutputArray(16, 0) = T3
vOutputArray(17, 0) = P4
vOutputArray(18, 0) = T4
vOutputArray(19, 0) = P5
vOutputArray(20, 0) = T5
vOutputArray(21, 0) = P6
vOutputArray(22, 0) = T6
vOutputArray(23, 0) = MEP
vOutputArray(24, 0) = Q_loss
vOutputArray(25, 0) = gamma_avg_C
vOutputArray(26, 0) = gamma_avg_E
vOutputArray(27, 0) = Lube_Oil_HT
vOutputArray(28, 0) = Radiation_Loss
vOutputArray(29, 0) = Heat_Rate_SI
vOutputArray(30, 0) = y_O2_x
vOutputArray(31, 0) = y_CO2_x
vOutputArray(32, 0) = y_H2O_x
vOutputArray(33, 0) = y_N2Ar_x
vOutputArray(34, 0) = W_Net / N_Cyl
vOutputArray(35, 0) = Piston_Speed
vOutputArray(36, 0) = Mfuel / Mair
vOutputArray(37, 0) = Eta_v
vOutputArray(38, 0) = Q_Exhaust
vOutputArray(39, 0) = HB_Error * 100
vOutputArray(40, 0) = Q_loss / Q_in

ICE = vOutputArray

Exit Function
err_here:
ICE = Err.Number
'Err.Description
End Function

Function ICEOutputLabels() As Variant
Dim sOutputLabels(1 To 40, 1) As String

sOutputLabels(1, 0) = "T/C Compressor kW"
sOutputLabels(2, 0) = "T/C Turbine kW"
sOutputLabels(3, 0) = "Compression Stroke kW"
sOutputLabels(4, 0) = "Expansion Stroke kW"
sOutputLabels(5, 0) = "Net Engine kW"
sOutputLabels(6, 0) = "Engine Fuel Consumption, kW"
sOutputLabels(7, 0) = "Engine Efficiency"
sOutputLabels(8, 0) = "T/C Aftercooler Duty, kW"
sOutputLabels(9, 0) = "P1, psia"
sOutputLabels(10, 0) = "T1, F"
sOutputLabels(11, 0) = "P1b"
sOutputLabels(12, 0) = "T1b"
sOutputLabels(13, 0) = "P2"
sOutputLabels(14, 0) = "T2"
sOutputLabels(15, 0) = "P3"
sOutputLabels(16, 0) = "T3"
sOutputLabels(17, 0) = "P4"
sOutputLabels(18, 0) = "T4"
sOutputLabels(19, 0) = "P5"
sOutputLabels(20, 0) = "T5"
sOutputLabels(21, 0) = "P6"
sOutputLabels(22, 0) = "T6"
sOutputLabels(23, 0) = "MEP, MPa"
sOutputLabels(24, 0) = "Heat Loss, kW"
sOutputLabels(25, 0) = "Average gamma (Compression)"
sOutputLabels(26, 0) = "Average gamma (Expansion)"
sOutputLabels(27, 0) = "Lubricating Oil, kW"
sOutputLabels(28, 0) = "Radiation, kW"
sOutputLabels(29, 0) = "Heat Rate, kJ/kWh"
sOutputLabels(30, 0) = "O2"
sOutputLabels(31, 0) = "CO2"
sOutputLabels(32, 0) = "H2O"
sOutputLabels(33, 0) = "N2 + Ar"
sOutputLabels(34, 0) = "Power/Cylinder, kW"
sOutputLabels(35, 0) = "Piston Speed, m/s"
sOutputLabels(36, 0) = "Fuel/Air Ratio"
sOutputLabels(37, 0) = "Volumetric Eff."
sOutputLabels(38, 0) = "Exhaust Energy, kWth"
sOutputLabels(39, 0) = "HB Error, %"
sOutputLabels(40, 0) = "Qin Error"

ICEOutputLabels = sOutputLabels

End Function
Function GasTurbine(vInputArray As Variant, yAir As Variant, yFuel As Variant) As Variant
' Based on
' Journal of Engineering for Gas Turbines and Power JANUARY 2011, Vol. 133 / 011801-1
' "A Simple Parametric Model for the Analysis of Cooled Gas Turbines" by S. C. Gulen
' SCG - Bechtel Power, 02/14/13
'
Dim P1 As Single, P2 As Single, P3 As Single, P4 As Single, P5 As Single
Dim PR_COMP As Single, PR_COMP_D As Single, PR_TURB As Single, P2c As Single
Dim k As Single, CP1 As Single, CP2 As Single, CP3 As Single, CP4 As Single, CP4c As Single, CP5 As Single
Dim T1 As Single, T2 As Single, T2c As Single, T3 As Single, T4 As Single, T5 As Single, T5c As Single
Dim Tfuel As Single, Hinj As Single, TIT As Single, RIT As Single, T3_ISO2314 As Single
Dim h1 As Single, h2 As Single, H2c As Single, h3 As Single, h4 As Single, h5 As Single, H5c As Single
Dim H2c_0 As Single, HXFB As Single, HFUEL As Single
Dim W1 As Single, W2 As Single, W3 As Single, W4 As Single, W5 As Single
Dim s5 As Single, MW5 As Single, S59 As Single, H59 As Single, Ex5 As Single
Dim w_ch As Single, w_nch As Single, w_tot As Single, w_oblk As Single
Dim WCH As Single, WNCH As Single, WINJ As Single, WXFB As Single, WFUEL As Single
Dim ETACP_MAX As Single, ETATP_MAX As Single, ETACP As Single, ETATP As Single
Dim QSC_FRAC As Single, QCAC_FRAC As Single
Dim beta As Single, phi As Single, PHI_INF As Single, TB As Single, MU_C As Single
Dim dP_in As Single, DP_EXH As Single, DP_COMB As Single
Dim PAMB As Single, Tamb As Single
Dim L_COMB As Single, L_MECH As Single, EFF_GEN As Single, W_GT_SHAFT As Single, w_sp As Single
Dim w_comp As Single, w_turb As Single, W_GT As Single, Eff_GT As Single, HR_GT As Single, HC As Single
Dim Fuel_LHV As Single, Q_SC As Single, Q_CAC As Single, Q_SC_CMB As Single, Q_SC_S1N As Single, Q_SC_HGP As Single
Dim Q_COOL As Single, q_c As Single, GTCV_Q_IN As Single, GTCV_Q_OUT As Single, HB_Error As Single, MB_ERROR As Single
Dim DELTA As Single, alfa As Single, THETA As Single, THETA_MAX As Single, C_ch As Single, C_nch As Single
Dim C_ch_D As Single, C_nch_D As Single
Dim i_CompBleedStage As Integer, i As Integer, j As Integer, jj As Integer, ji As Integer, n As Integer
Dim x_a(1 To 6) As Single, MWAIR As Single, x_4g(1 To 6) As Single, x_5g(1 To 6) As Single, y_4g(1 To 6) As Single
Dim x_3g(1 To 6) As Single, y_3g(1 To 6) As Single, y_5g(1 To 6) As Single
Dim S1N_Pseudo_AeN As Single, S1N_Pseudo_AeN_D As Single
Dim GT_Class As String, iOFFD As Integer
Dim vOutputArray(1 To 30, 1) As Single
Dim varCombust As Variant
Dim bFIND_CH As Boolean
Const N_Comp_Stages As Integer = 18
Const T2c_MIN As Single = 350
On Local Error GoTo err_here
' Read the input array:
W1 = vInputArray(1)
WFUEL = vInputArray(2)
WINJ = vInputArray(3)
WXFB = vInputArray(4)
ETACP_MAX = vInputArray(5)
ETATP_MAX = vInputArray(6)
Tfuel = vInputArray(7)
PR_COMP_D = vInputArray(8)
TIT = vInputArray(9)
RIT = vInputArray(10)
QSC_FRAC = vInputArray(11)
QCAC_FRAC = vInputArray(12)
beta = vInputArray(13)
PHI_INF = vInputArray(14)
TB = vInputArray(15)
dP_in = vInputArray(16) 'inlet loss in in. of H2O
DP_EXH = vInputArray(17)    'exhaust loss in in. of H2O
DP_COMB = vInputArray(18)
PAMB = vInputArray(19)
Tamb = vInputArray(20)
L_COMB = vInputArray(21)
L_MECH = vInputArray(22)
EFF_GEN = vInputArray(23)
w_oblk = vInputArray(24)
DELTA = vInputArray(25)
alfa = vInputArray(26)
MU_C = vInputArray(27)
Hinj = vInputArray(28)
i_CompBleedStage = vInputArray(29)
GT_Class = Trim(vInputArray(30))
' Initialize chargeable and nonchargeable flows
w_nch = vInputArray(31)
' if the user input is negative, use it "as is"
If vInputArray(32) < 0 Then
    bFIND_CH = False
Else
    bFIND_CH = True
End If
w_ch = Abs(vInputArray(32))
S1N_Pseudo_AeN_D = vInputArray(33)
iOFFD = Int(vInputArray(34))    '1: Off-Design, 0: Design
C_ch_D = vInputArray(35)   'Chargeable flow C-factor (design)
C_nch_D = vInputArray(36)  'Nonchargeable flow C-factor (design)
' Mass composition of air:
i = Convert_Fractions(yAir, 6, 1)
For i = 1 To 6
    x_a(i) = cfout(i, 0)
Next i
MWAIR = MWgas(yAir, 6)  'Mol. wt. of air..
T1 = Tamb
h1 = hgas(T1, x_a, 6, 2)
CP1 = Cpgas(T1, yAir, 6, 2) / MWAIR
' Calculate fuel LHV
Fuel_LHV = Calc_Fuel_LHV(yFuel)
' Initialize heat consumption, T4
HC = WFUEL * Fuel_LHV
T4 = RIT
' Calculate pressures:
P1 = PAMB - dP_in * 0.036127291827
P5 = PAMB + DP_EXH * 0.036127291827
PR_COMP = PR_COMP_D
'------------> Start of compressor PR iteration:
jj = 1
5:
P2 = PR_COMP * P1
P3 = P2 * (1 - DP_COMB)
P4 = P3 * DELTA
PR_TURB = P4 / P5
'Compressor:
T2 = T1
ETACP = ETACP_MAX - 0.005 * Log(PR_COMP)    'Eq. 25a in Gulen
For i = 1 To N_Comp_Stages
    k = 1 - 1 / gamma(T2, yAir, 6)
    T2 = (T2 + 459.67) * (PR_COMP ^ (1 / N_Comp_Stages)) ^ (k / ETACP) - 459.67
    If i = i_CompBleedStage Then
        T2c = T2
        P2c = P1 * PR_COMP ^ (i / N_Comp_Stages)
    End If
Next i
h2 = hgas(T2, x_a, 6, 2)
CP2 = Cpgas(T2, yAir, 6, 2) / MWAIR
H2c_0 = hgas(T2c, x_a, 6, 2)
'
'------------> Start of chargeable flow iteration:
If (jj = 1) Then j = 1 'don't initialize more than once!!
10:
Q_SC = QSC_FRAC * HC
Select Case GT_Class
    Case "G"
        Q_SC_CMB = Q_SC
        Q_SC_S1N = 0
        Q_SC_HGP = 0
        THETA_MAX = 0.3
    Case "J"
    Case "H"
        Q_SC_CMB = 0
        Q_SC_S1N = 0.75 * Q_SC
        Q_SC_HGP = 0.25 * Q_SC
        THETA_MAX = 0.6
    Case Else   'E, F, etc..
        Q_SC = 0
        Q_SC_CMB = 0
        Q_SC_S1N = 0
        Q_SC_HGP = 0
End Select
'
' Cooling air cooler duty (if any)
ji = 1 'This iteration only in OFFD with CAC
7:
If (iOFFD = 1) Then 'Off-Design
' Use C-factor to calculate coolant flow..
    WCH = C_ch_D * (P2c * Sqr(MWAIR / (T2c + 459.67)))
Else
    WCH = w_ch * W1
End If
Q_CAC = QCAC_FRAC * HC
H2c = H2c_0 - Q_CAC / WCH
T2c = Find_Tgas(100, 1100, x_a, 6, 2, H2c)
If (T2c < T2c_MIN) Then
    T2c = T2c_MIN
    H2c = hgas(T2c, x_a, 6, 2)
    Q_CAC = WCH * (H2c_0 - H2c)
    QCAC_FRAC = Q_CAC / HC
End If
If (iOFFD = 1) Then 'Off-Design
  If (QCAC_FRAC > 0) Then  'there is CAC
    If (ji < 5) Then ' iterate to fix Wch and T2c..
        ji = ji + 1
        GoTo 7
    End If
  End If
End If
' Turbine coolant duty (chargeable flow):
Q_COOL = WCH * (hgas(TB, x_a, 6, 2) - H2c)
' Cooling effectiveness:
phi = (T4 - TB) / (T4 - T2c)
' Steam cooling duty (if any)
THETA = Q_SC / Q_COOL
If (THETA > THETA_MAX) Then
    THETA = THETA_MAX
    Q_SC = THETA * Q_COOL
    QSC_FRAC = Q_SC / HC
End If
' Chargeable coolant flow calculation
' (only for design case)
If (iOFFD <> 1) Then    'Design
'Use cooling effectiveness method:
    WCH = MU_C * W1 * (phi / (PHI_INF - phi)) ^ beta * (1 - THETA)
End If
If bFIND_CH Then
    w_ch = WCH / W1
Else
    WCH = w_ch * W1
End If
' Non-chargeable coolant flow calculation
If (iOFFD <> 1) Then    'Design
' use the user-provided value:
    WNCH = w_nch * W1
Else
    WNCH = C_nch_D * (P2 * Sqr(MWAIR / (T2 + 459.67)))
End If
W2 = W1 * (1 - w_oblk) - WCH - WNCH
'
' Combustion
' First to determine turbine inlet:
e_comb = 1 - L_COMB
Comb_Ext_Cooling = Q_SC_CMB
' ISO-2314 TIT (Reference Value)
varCombust = Combust(W1, WFUEL, WINJ, Hinj, yAir, yFuel, T2, Tfuel)
T3_ISO2314 = CSng(varCombust(1, 0))
' "Real" TIT:
varCombust = Combust(W2, WFUEL, WINJ, Hinj, yAir, yFuel, T2, Tfuel)
T3 = CSng(varCombust(1, 0))
W3 = W2 + WFUEL + WINJ
'
' Get gas compositions:
For i = 1 To 6
    x_3g(i) = cfout(i, 0)
Next i
i = Convert_Fractions(x_3g, 6, 2)
For i = 1 To 6
    y_3g(i) = cfout(i, 0)
Next i
' Recalculate Compressor Pressure:
' Choked nozzle assumption..
If iOFFD = 1 Then
    PR_COMP = PR_COMP_D * (S1N_Pseudo_AeN_D / 10000) * Sqr((T3 + 459.67) / MWgas(y_3g, 6)) * W3
    If (jj <= 3) Then
        jj = jj + 1
        GoTo 5
    End If
End If
S1N_Pseudo_AeN = 10000# * Sqr(MWgas(y_3g, 6) / (T3 + 459.67)) / W3
'..then to determine S1B inlet:
Comb_Ext_Cooling = Q_SC_CMB + Q_SC_S1N
varCombust = Combust(W2 + WNCH, WFUEL, WINJ, Hinj, yAir, yFuel, T2, Tfuel)
T4 = CSng(varCombust(1, 0))
If (iOFFD = 1) Then
    If (T4 > RIT) Then  'Do not overfire!!
        WFUEL = Find_Mfuel(0.5 * WFUEL, WFUEL, yAir, yFuel, WINJ, Hinj, W2 + WNCH, T2, Tfuel, RIT)
        T4 = RIT
    End If
End If
W4 = W3 + WNCH
'
If (iOFFD <> 1) Then
  If bFIND_CH Then
    If (j <= 10) Then
        j = j + 1
        GoTo 10
    End If
  End If
End If
' Get gas compositions:
For i = 1 To 6
    x_4g(i) = cfout(i, 0)
Next i
i = Convert_Fractions(x_4g, 6, 2)
For i = 1 To 6
    y_4g(i) = cfout(i, 0)
Next i
'
' Turbine Calculations:
n = 100
h4 = hgas(T4, x_4g, 6, 2)
ETATP = ETATP_MAX - 0.01 * Log(PR_TURB) * (1 + Sqr(w_ch)) 'Eq. 25b in Gulen
' Eq. 11 in Gulen
T5 = T4
For i = 2 To n + 1
    k = 1 - 1 / gamma(T5, y_4g, 6)
    CP4 = Cpgas(T5, y_4g, 6, 2) / MWgas(y_4g, 6)
    T5 = (T5 + 459.67) / (PR_TURB ^ (1 / n)) ^ (k * ETATP) - (Q_COOL / n) / (W4 * CP4) - 459.67
Next i
h5 = hgas(T5, x_4g, 6, 2)
w_turb = W4 * (h4 - h5) * 1.05506   'Do this here before H5 changes below due to mixing..
' Eq. 10 in Gulen
T5c = T2c
For i = 2 To n + 1
    k = 1 - 1 / gamma(T5c, yAir, 6)
    CP4c = Cpgas(T5c, yAir, 6, 2) / MWAIR
    T5c = (T5c + 459.67 + ((Q_COOL - Q_SC_HGP) / n) / (WCH * CP4c)) / (PR_TURB ^ (1 / n)) ^ (k * ETATP) - 459.67
Next i
H5c = hgas(T5c, x_a, 6, 2)
'
' Mixing of gas, coolant and exhaust frame blower streams:
HXFB = hgas(110, x_a, 6, 2) 'assume 110F
W5 = W4 + WCH + WXFB    'GT exhaust flow..
h5 = (W4 * h5 + WCH * H5c + WXFB * HXFB) / W5
'Calculate exhaust gas mass fractions:
For i = 1 To 6
    x_5g(i) = (x_4g(i) * W4 + x_a(i) * (WCH + WXFB)) / W5
Next i
T5 = Find_Tgas(500, 1500, x_5g, 6, 2, h5)   'GT exhaust temperature..
i = Convert_Fractions(x_5g, 6, 2)
For i = 1 To 6
    y_5g(i) = cfout(i, 0)
Next i
MW5 = MWgas(y_5g, 6)
S59 = sgas(59, 14.7, y_5g, 6) / MW5 ' reference entropy, Btu/lb-R
H59 = hgas(59, x_5g, 6, 2)
s5 = sgas(T5, P5, y_5g, 6) / MW5
Ex5 = (h5 - H59) - 518.67 * (s5 - S59)  'Exhaust exergy, Btu/lb
'
' Calculate power
w_turb = w_turb + WCH * (H2c - H5c) * 1.05506   'Update turbine power..
w_comp = (W1 - WCH) * (h2 - h1) * 1.05506
w_comp = w_comp + WCH * (H2c_0 - h1) * 1.05506
W_GT_SHAFT = w_turb - w_comp
W_GT = W_GT_SHAFT * (1 - L_MECH) * EFF_GEN
W_GT = W_GT * (1 - alfa)
w_sp = W_GT / W1
Eff_GT = W_GT / (HC * 1.05506)
HR_GT = 3412.14 / Eff_GT
'
' Check heat balance:
HFUEL = Tfuel ^ 2 / 4720 + 0.491 * Tfuel - 30.2
GTCV_Q_IN = W1 * h1 + WFUEL * (Fuel_LHV + HFUEL) + WINJ * Hinj + WXFB * HXFB
GTCV_Q_OUT = W_GT_SHAFT / 1.05506 + L_COMB * HC + Q_CAC + Q_SC + W5 * h5
HB_Error = Abs(GTCV_Q_IN - GTCV_Q_OUT) / HC
MB_ERROR = (W5 + w_oblk * W1) - (W1 + WFUEL + WINJ + WXFB)
'
'Leakage C factors:
C_ch = WCH / (P2c * Sqr(MWAIR / (T2c + 459.67)))
C_nch = WNCH / (P2 * Sqr(MWAIR / (T2 + 459.67)))
'
vOutputArray(1, 0) = W_GT
vOutputArray(2, 0) = Eff_GT
vOutputArray(3, 0) = HR_GT
vOutputArray(4, 0) = w_sp
vOutputArray(5, 0) = W1
vOutputArray(6, 0) = WFUEL
vOutputArray(7, 0) = W2
vOutputArray(8, 0) = W3
vOutputArray(9, 0) = W4
vOutputArray(10, 0) = W5
vOutputArray(11, 0) = T2
vOutputArray(12, 0) = T2c
vOutputArray(13, 0) = T3
vOutputArray(14, 0) = T4
vOutputArray(15, 0) = T5
vOutputArray(16, 0) = w_ch
vOutputArray(17, 0) = w_nch
vOutputArray(18, 0) = ETACP
vOutputArray(19, 0) = ETATP
vOutputArray(20, 0) = QSC_FRAC
vOutputArray(21, 0) = QCAC_FRAC
vOutputArray(22, 0) = S1N_Pseudo_AeN
vOutputArray(23, 0) = PR_COMP
vOutputArray(24, 0) = MB_ERROR
vOutputArray(25, 0) = HB_Error
vOutputArray(26, 0) = C_ch
vOutputArray(27, 0) = C_nch
vOutputArray(28, 0) = T3_ISO2314
vOutputArray(29, 0) = (W5 * h5) * 1.05506
vOutputArray(30, 0) = (W5 * Ex5) * 1.05506

GasTurbine = vOutputArray

Exit Function
err_here:
GasTurbine = Err.Number
'Err.Description
End Function

Function GTOutputLabels() As Variant
Dim sOutputLabels(1 To 30, 1) As String

sOutputLabels(1, 0) = "W_GT"
sOutputLabels(2, 0) = "Eff_GT"
sOutputLabels(3, 0) = "HR_GT"
sOutputLabels(4, 0) = "w_sp"
sOutputLabels(5, 0) = "W1"
sOutputLabels(6, 0) = "WFUEL"
sOutputLabels(7, 0) = "W2"
sOutputLabels(8, 0) = "W3"
sOutputLabels(9, 0) = "W4"
sOutputLabels(10, 0) = "W5"
sOutputLabels(11, 0) = "T2"
sOutputLabels(12, 0) = "T2c"
sOutputLabels(13, 0) = "T3"
sOutputLabels(14, 0) = "T4"
sOutputLabels(15, 0) = "T5"
sOutputLabels(16, 0) = "w_ch"
sOutputLabels(17, 0) = "w_nch"
sOutputLabels(18, 0) = "ETACP"
sOutputLabels(19, 0) = "ETATP"
sOutputLabels(20, 0) = "QSC_FRAC"
sOutputLabels(21, 0) = "QCAC_FRAC"
sOutputLabels(22, 0) = "S1N_Pseudo_AeN"
sOutputLabels(23, 0) = "COMP_PR"
sOutputLabels(24, 0) = "MB_ERROR"
sOutputLabels(25, 0) = "HB_ERROR"
sOutputLabels(26, 0) = "C_ch"
sOutputLabels(27, 0) = "C_nch"
sOutputLabels(28, 0) = "T3(ISO-2314)"
sOutputLabels(29, 0) = "Q5_kW"
sOutputLabels(30, 0) = "E5_kW"

GTOutputLabels = sOutputLabels

End Function

Function Comp_Eff_Adiabatic(PR As Single, T1 As Single, ETACP_MAX As Single, yAir As Variant)
'Compressor:
Dim x_a(1 To 6) As Single
Dim T2 As Single, h1 As Single, h2 As Single, h2s As Single, ETACP As Single, k As Single
Dim M2_Corr As Single, EPoly
Dim i As Integer
Const N_Comp_Stages As Integer = 18
Const PR_0 As Single = 19
Const T2_0 As Single = 724.4382
Const M2_0 As Single = 800

' Mass composition of air:
i = Convert_Fractions(yAir, 6, 1)
For i = 1 To 6
    x_a(i) = cfout(i, 0)
Next i
h1 = hgas(T1, x_a, 6, 2)

T2 = T1
For i = 1 To N_Comp_Stages
    k = 1 - 1 / gamma(T2, yAir, 6)
    T2 = (T2 + 459.67) * (PR ^ (1 / N_Comp_Stages)) ^ k - 459.67
Next i
h2s = hgas(T2, x_a, 6, 2)
M2_Corr = M2_0 * Sqr(T2 + 459.67) / (PR * 14.7)
EPoly = 0.910050260908819 + 5.95164765276949E-05 * M2_Corr + -6.07394938742294E-02 * M2_Corr ^ (-0.658612017650639) / M2_Corr
M2_Corr = Sqr(T2 + 459.67) / Sqr(T2_0 + 459.67) * (PR_0 / PR)

T2 = T1
ETACP = EPoly 'ETACP_MAX '- 0.01 * Log(PR)    'Eq. 25a in Gulen
For i = 1 To N_Comp_Stages
    k = 1 - 1 / gamma(T2, yAir, 6)
    T2 = (T2 + 459.67) * (PR ^ (1 / N_Comp_Stages)) ^ (k / ETACP) - 459.67
Next i
h2 = hgas(T2, x_a, 6, 2)

Comp_Eff_Adiabatic = (h1 - h2s) / (h1 - h2)

End Function

